package labss.lang.il.test;

import labss.lang.il.model.*;
import labss.lang.il.model.impl.ILLanguageFactory;

public class Example {
	public static void main(String[] args) {
		LanguageFactory lf = ILLanguageFactory.instance();
		
		fact(lf);
	}
	
	public static void fact(LanguageFactory lf) {
		Expression n = lf.createVariable("n");
		Expression result = lf.createVariable("result");
		Statement fatt = lf.createBlock(new Statement[] {
				lf.createAssignment(n, lf.createLiteral(4)),
				lf.createAssignment(result, lf.createLiteral(1)),
				lf.createWhile(lf.createGreaterThan(n, lf.createLiteral(0)), lf.createBlock(new Statement[] {
						lf.createAssignment(result, lf.createMultiplication(result, n)),
						lf.createAssignment(n,lf.createSubtraction(n, lf.createLiteral(1)))
				}))
		});
		
		fatt.prettyPrint(System.out);
		fatt.execute();
		System.out.println("n! = " + result);
	}
}
